# -*- coding: utf-8 -*-
"""
Created on Wed May 10 17:39:12 2023

@author: user
"""

# Load libraries
import numpy as np
from keras.datasets import reuters
from keras.utils.np_utils import to_categorical
from keras.preprocessing.text import Tokenizer
from sklearn.metrics import classification_report
from keras import models
from keras import layers
import tensorflow as tf
# Set random seed
import random
random.seed(0)
np.random.seed(0)
tf.random.set_seed(0)
# Set the number of features we want
number_of_features = 5000
# Load feature and target data
data = reuters.load_data(num_words=number_of_features)
(data_train, target_vector_train), (data_test, target_vector_test) = data
# Convert feature data to a one-hot encoded feature matrix
tokenizer = Tokenizer(num_words=number_of_features)
features_train = tokenizer.sequences_to_matrix(data_train, mode="binary")
features_test = tokenizer.sequences_to_matrix(data_test, mode="binary")
# One-hot encode target vector to create a target matrix
target_train = to_categorical(target_vector_train)
target_test = to_categorical(target_vector_test)
# Start neural network
network = models.Sequential()
# Add fully connected layer with a ReLU activation function
network.add(layers.Dense(units=100,activation="relu",input_shape=(number_of_features,)))

# Add fully connected layer with a ReLU activation function
network.add(layers.Dense(units=100, activation="relu"))
# Add fully connected layer with a softmax activation function
network.add(layers.Dense(units=46, activation="softmax"))
# Compile neural network
network.compile(loss="categorical_crossentropy", # Cross-entropy
optimizer="rmsprop", # Root Mean Square Propagation
metrics=["accuracy"]) # Accuracy performance metric
# Train neural network
history = network.fit(features_train, # Features
target_train, # Target
epochs=3, # Three epochs
verbose=1,  
batch_size=100, # Number of observations per batch
validation_data=(features_test, target_test)) # Test data


from sklearn.metrics import confusion_matrix
import numpy as np


# Predict classes on the test set
predicted_classes = np.argmax(network.predict(features_test), axis=1)

# Convert one-hot encoded target_test back to categorical labels
true_classes = np.argmax(target_test, axis=1)

# Calculate the confusion matrix
conf_matrix = confusion_matrix(true_classes, predicted_classes)


# Print the results
print("Confusion Matrix:")
print(conf_matrix)


#evaluation
print(classification_report(true_classes, predicted_classes))


